/******************************************************************************/
/* *.OBJ LOADER HEADER by ROB BATEMAN                  10/May/2000	      */
/******************************************************************************/

#ifndef OBJ_H
#define OBJ_H

#include <GL/glut.h>

/* Structure Definitions =====================================================*/ 
/*============================================================================*/ 

/* data structure for vertices */
struct Objvertex 
{
  int ID_NUM; 
  float x; 
  float y; 
  float z; 
  struct Objvertex *nextPtr; 
}; 
typedef struct Objvertex ObjVERTEX; 
typedef ObjVERTEX *VERTEXPTR; 


/* data structure for tex coords */
struct tex_vertex
{
  int ID_NUM; 
  float x; 
  float y; 
  float z; 
  struct tex_vertex *nextPtr; 
}; 
typedef struct tex_vertex TEXVERTEX; 
typedef TEXVERTEX *TEXVERTEXPTR; 


/* data structure for normals */
struct normal
{
  int ID_NUM; 
  float x; 
  float y; 
  float z; 
  struct normal *nextPtr; 
}; 
typedef struct normal NORMAL; 
typedef NORMAL *NORMALPTR; 


/* face structure references above queues */
struct face 
{
  int IDNUM;
  GLuint texture; 
  VERTEXPTR va; 
  VERTEXPTR vb; 
  VERTEXPTR vc; 
  VERTEXPTR vd; 
  NORMALPTR na; 
  NORMALPTR nb; 
  NORMALPTR nc; 
  NORMALPTR nd; 
  TEXVERTEXPTR ta; 
  TEXVERTEXPTR tb; 
  TEXVERTEXPTR tc; 
  TEXVERTEXPTR td; 
  struct face *nextPtr; 
}; 
typedef struct face FACE; 
typedef FACE *FACEPTR; 
 
 
/* Function Prototypes =======================================================*/ 
/*============================================================================*/ 
 
VERTEXPTR pass_id(int,VERTEXPTR); 	/* function to take node id, returns pointer */
TEXVERTEXPTR pass_idt(int,TEXVERTEXPTR); 
NORMALPTR pass_idn(int,NORMALPTR); 
 
void enqueue_vertex(VERTEXPTR *, VERTEXPTR *, float, float, float ); 
void enqueue_normal(NORMALPTR *, NORMALPTR *, float, float, float); 
void enqueue_texture_vertex(TEXVERTEXPTR *,TEXVERTEXPTR *, float, float, float ); 
void enqueue_face(FACEPTR *,FACEPTR *,VERTEXPTR,TEXVERTEXPTR,NORMALPTR,
				      int,int,int,int,
				      int,int,int,int,
				      int,int,int,int,int); 
 
void dequeue_vertex(VERTEXPTR *, VERTEXPTR *); 
void dequeue_face(FACEPTR *, FACEPTR *); 
void dequeue_normal(NORMALPTR *,NORMALPTR *); 
void dequeue_texture_vertex(TEXVERTEXPTR *,TEXVERTEXPTR *); 
 
extern int LoadObjData(char *, int ,GLuint);
//extern GLuint load_texture ( char * ); //removed by dfletcher
static void draw_Obj(FACEPTR,int,GLuint );
//extern void compile_Material ( float ,float ,float ,float ,
//				float ,float ,float ,float ,
//				float ,float ,float ,float ,
//				float ,float ,float ,float ,
//				int ,GLuint );
 

#endif

